unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, CompressWaveLib, ddsd, ComCtrls, math;

const _STREAMSIZE = 44100 * 4;     //8̔{łȂ22KHzĐɁEEE

type
  TForm1 = class(TForm)
    Memo1: TMemo;
    Button1: TButton;
    Image1: TImage;
    ScrollBar1: TScrollBar;
    Image3: TImage;
    Button2: TButton;
    Button3: TButton;
    DDSD1: TDDSD;
    Button4: TButton;
    OpenDialog1: TOpenDialog;
    Button5: TButton;
    SaveDialog1: TSaveDialog;
    Button7: TButton;
    OpenDialog2: TOpenDialog;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Button10: TButton;
    Button11: TButton;
    Button12: TButton;
    Button13: TButton;
    SaveDialog2: TSaveDialog;
    Edit1: TEdit;
    procedure Button1Click(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure ScrollBar1Change(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Button7Click(Sender: TObject);
    procedure Button10Click(Sender: TObject);
    procedure Button13Click(Sender: TObject);
    procedure Button11Click(Sender: TObject);
  private
    { Private 錾 }
  public
    { Public 錾 }
    ss1,ss3 : TMemoryStream;
    Pwav : TCompressWaveData;

    DataPos : Int64;
    Vol : Integer;
    UseTbl : array[0..15] of int64;
    PlayNo : Integer;

    wav:TDDSDWaveData;
    WavBuf : TMemoryStream;
    PlayCount : DWORD;

    LoopCount : Integer;
    LoopStart,LoopEnd : Single;

    procedure UpdateWav(Sender:TDDSDGenWave; Player:TDDSDChannel; ofs,len:Cardinal);
    procedure DrawWaveLine;
    procedure MusicStop;

    procedure ReSampleWave(var dest:TMemoryStream; src:TMemoryStream);
  end;

var
  Form1: TForm1;

implementation

uses Unit2;

{$R *.dfm}

procedure TForm1.Button1Click(Sender: TObject);
var
  tt : DWORD;
  Cha,Smp : Integer;
  TableValue : Single;
begin
  //ĐȂ~߂
  MusicStop;
  //O
  if (ss1 = nil)then exit;
  //kp[^̓ǂݍ
  LoopStart := StrToFloatDef(Form2.Edit3.Text,0);
  LoopEnd   := StrToFloatDef(Form2.Edit4.Text,10);
  LoopCount := StrToIntDef(Form2.Edit6.Text,0);
  Cha := 2;
  Smp := 44100;
  if (Form2.CheckBox1.Checked = TRUE)then Smp := 22050;
  if (Form2.CheckBox2.Checked = TRUE)then Cha := 1;
  TableValue := Form2.TrackBar1.Position / 1000;
  //k
  Memo1.Lines.Add(format('[%s]B',[Opendialog1.Filename]));
  tt := GetTickCount;
  PWav.MakeTable(TableValue);
  PWav.Hed.Channel := Cha;
  PWav.Hed.Sample  := Smp;
  PWav.SetCipherCode(DWORD(StrToInt64Def(Form2.Edit7.Text,0)));
  PWav.Hed.LoopStart := round(LoopStart * (44100*4));
  PWav.Hed.LoopEnd   := round(LoopEnd   * (44100*4));
  PWav.Hed.LoopCount := LoopCount;
  PWav.Hed.MusicTitle := Form2.Edit2.Text;
  PWav.Hed.MusicArtist:= Form2.Edit5.Text;
  PWav.PressFromStream(ss1);
  Memo1.Lines.Add(format('kvԁF%d msec',[GetTickCount-tt]));
  //WJ
  tt := GetTickCount;
  PWav.UnPressToStream(ss3);
  Memo1.Lines.Add(format('WJvԁF%d msec',[GetTickCount-tt]));
  //TCY
  Memo1.Lines.Add(Format('TCYr F%d/%d (%f)',[ss1.size,PWav.Data.Size,PWav.Data.Size/ss1.size]));
  Memo1.Lines.Add('');
  //ʍXV
  DrawWaveLine;
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  DDSD1[0].Stop;
  PlayCount := 0;

  if (ss1  <> nil)then ss1.Free;
  if (Pwav <> nil)then Pwav.Free;
  if (ss3  <> nil)then ss3.Free;
  if (wav  <> nil)then wav.Free;
  if (WavBuf <> nil)then WavBuf.Free;
end;

procedure TForm1.ScrollBar1Change(Sender: TObject);
begin
  if (PlayNo = 0)then
  begin
    PlayCount := ScrollBar1.Position - (ScrollBar1.Position mod 4);     //₵
    DrawWaveLine;
  end;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  PlayNo := 0;
  DDSD1.SetPrimaryBufferFotmat(44100, 16, True);

  WavBuf := TMemoryStream.Create;
  WavBuf.SetSize(_STREAMSIZE div 2);
  pwav := TCompressWaveData.Create;
  wav:=TDDSDWaveData.CreateStream(DDSD1, 44100, 16, TRUE, _STREAMSIZE);
  wav.OnUpdate:=UpdateWav;
  DDSD1[0].WaveData:=wav;

  LoopCount := 0;
  LoopStart := -1;
  LoopEnd   := -1;
end;

procedure TForm1.UpdateWav(Sender:TDDSDGenWave; Player:TDDSDChannel; ofs,len:Cardinal);
var
  size : Integer;
begin
  case PlayNo of
    0 : begin
          FillMemory(WavBuf.Memory,len,0);
        end;
    1 : begin
          FillMemory(WavBuf.Memory,len,0);
          WavBuf.Position := 0;
          ss1.Position := sizeof(WAVEDATAHED)+PlayCount;
          size := Min(ss1.Size-ss1.Position,len);
          WavBuf.CopyFrom(ss1,size);
          PlayCount := PlayCount + len;
          if (PlayCount > (ss1.Size-sizeof(WAVEDATAHED)))then PlayCount := 0;
        end;
    2 : begin
          FillMemory(WavBuf.Memory,len,0);
          WavBuf.Position := 0;
          ss3.Position := sizeof(WAVEDATAHED)+PlayCount;
          size := Min(ss3.Size-ss3.Position,len);
          WavBuf.CopyFrom(ss3,size);
          PlayCount := PlayCount + len;
          if (PlayCount > (ss3.Size-sizeof(WAVEDATAHED)))then PlayCount := 0;
        end;
    3 : begin    //gpȂ
          //Pwav.Rendering(WavBuf.Memory,len);
        end;
  end;

  wav.BlockCopy(ofs,WavBuf.Memory,len);
  Edit1.Text := format('%.3f-%.3f sec',[PlayCount / (44100*4),(PlayCount+2400) / (44100*4)]);
  ScrollBar1.Position := PlayCount;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  if (ss1 = nil)then exit;
  MusicStop;
  PlayNo := 1;
  DDSD1[0].LoopPlay;
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
  if (ss3 = nil)then exit;
  MusicStop;
  PlayNo := 2;
  DDSD1[0].LoopPlay;
end;

procedure TForm1.Button4Click(Sender: TObject);
begin
  MusicStop;
  DrawWaveLine;
end;

procedure TForm1.Button5Click(Sender: TObject);
var
  LoopStart,LoopEnd : Single;
  LoopCount : Integer;
begin
  MusicStop;
  if (length(Opendialog1.FileName) > 4)then
  begin
    SaveDialog1.FileName := copy(Opendialog1.FileName,0,length(Opendialog1.FileName)-4) + '.cwav';
  end;
  if (SaveDialog1.Execute = FALSE)then exit;
  //wb_̍XV
  LoopStart := StrToFloatDef(Form2.Edit3.Text,0);
  LoopEnd   := StrToFloatDef(Form2.Edit4.Text,10);
  LoopCount := StrToIntDef(Form2.Edit6.Text,0);
  PWav.Hed.LoopStart := round(LoopStart * (44100*4));
  PWav.Hed.LoopEnd   := round(LoopEnd   * (44100*4));
  PWav.Hed.LoopCount := LoopCount;
  PWav.Hed.MusicTitle := Form2.Edit2.Text;
  PWav.Hed.MusicArtist:= Form2.Edit5.Text;
  Pwav.HedUpdata;
  Pwav.SaveToFile(SaveDialog1.FileName);
end;

procedure TForm1.Button7Click(Sender: TObject);
var
  tt : DWORD;
begin
  //Ȃ~߂
  MusicStop;
  //t@CI
  if (Opendialog2.Execute = FALSE)then exit;
  //WAVEǂݍ܂Ă
  if (ss1 <> nil)then ss1.Free;
  ss1 := nil;
  //ǂݍޑOɁAÍR[hݒ
  PWav.SetCipherCode(DWORD(StrToInt64Def(Form2.Edit7.Text,0)));
  //kt@Cǂݍ
  Pwav.LoadFromFile(Opendialog2.FileName);
  //\
  Memo1.Lines.Add(Format('[%s]ǂݍ݂܂',[Opendialog2.Filename]));
  //WJ
  tt := GetTickCount;
  PWav.UnPressToStream(ss3);
  Memo1.Lines.Add(format('WJvԁF%d msec',[GetTickCount-tt]));
  //XN[o[̏ݒ
  ScrollBar1.Min := 0;
  ScrollBar1.Max := Pwav.Hed.UnPressSize - 2400 - sizeof(WaveDataHed)*4;
  ScrollBar1.Position := 0;
  //TCY
  Memo1.Lines.Add(Format('TCYr F%d/%d (%f)',[ss3.size,PWav.Data.Size,PWav.Data.Size/ss3.size]));
  Memo1.Lines.Add('');
  //ʍXV
  DrawWaveLine;
  //wb_Xe[^XXV
  Form2.Edit2.Text := pwav.Hed.MusicTitle;
  Form2.Edit5.Text := pwav.Hed.MusicArtist;
  Form2.Edit6.Text := IntToStr(pwav.Hed.LoopCount);
  Form2.Edit3.Text := FloatToStr(pwav.Hed.LoopStart / (44100*4));
  Form2.Edit4.Text := FloatToStr(pwav.Hed.LoopEnd / (44100*4));
end;

procedure TForm1.Button10Click(Sender: TObject);
var
  tmp : TMemoryStream;
begin
  MusicStop;
  if (Opendialog1.Execute = FALSE)then exit;
  //kg`ǂݍ܂ĂΔj
  if (ss3 <> nil)then ss3.Free;
  ss3 := nil;
  //WAVEǂݍ
  tmp := TMemoryStream.Create;
  tmp.LoadFromFile(opendialog1.FileName);
  ReSampleWave(ss1,tmp);
  tmp.Free;
  //XN[o[̍ől̐ݒ
  ScrollBar1.Min := 0;
  ScrollBar1.Max := ss1.Size-sizeof(WAVEDATAHED)*4-2400;
  ScrollBar1.Position := 0;
  PlayCount := 0;
  //ʍXV
  DrawWaveLine;
  Form2.Edit2.Text := 'UnTitled';
  Form2.Edit5.Text := 'NoName';
  Form2.Edit6.Text := '0';
  Form2.Edit3.Text := '0';
  Form2.Edit4.Text := '10';
end;

procedure TForm1.Button13Click(Sender: TObject);
begin
  Form2.Show;
end;

procedure TForm1.Button11Click(Sender: TObject);
begin
  MusicStop;
  if (ss3 = nil)then exit;
  if (SaveDialog2.Execute = FALSE)then Exit;
  ss3.SaveToFile(SaveDialog2.FileName);
end;

procedure TForm1.DrawWaveLine;
var
  i,yy1,yy2,yy3,yy4 : Integer;
  aaa : SmallInt;
begin

  Image1.Canvas.Brush.Color := $02000000;
  Image3.Canvas.Brush.Color := $02000000;
  Image1.Canvas.FillRect(rect(0,0,732,210));
  Image3.Canvas.FillRect(rect(0,0,732,210));
  Image1.Canvas.Pen.Color := $02000000;
  Image3.Canvas.Pen.Color := $02000000;

  if (ss1 <> nil)then
  begin
    ss1.Position := PlayCount+sizeof(WAVEDATAHED);
    yy3 := 50;
    yy4 := 50;
    for i:=0 to 600 do
    begin
      ss1.Read(aaa,2);
      Image1.Canvas.Pen.Color := $02FF8888;
      yy1 := 100 + aaa*100 div 32767;
      Image1.Canvas.MoveTo(i,yy3);
      Image1.Canvas.LineTo(i+1,yy1);
      ss1.Read(aaa,2);
      Image1.Canvas.Pen.Color := $028888FF;
      yy2 := 100 + aaa*100 div 32767;
      Image1.Canvas.MoveTo(i,yy4);
      Image1.Canvas.LineTo(i+1,yy2);
      yy3 := yy1;
      yy4 := yy2;
    end;
  end;

  if (ss3 <> nil)then
  begin
    ss3.Position := PlayCount+sizeof(WAVEDATAHED);
    yy3 := 50;
    yy4 := 50;
    for i:=0 to 600 do
    begin
      ss3.Read(aaa,2);
      Image3.Canvas.Pen.Color := $02FF8888;
      yy1 := 100 + aaa*100 div 32767;
      Image3.Canvas.MoveTo(i,yy3);
      Image3.Canvas.LineTo(i+1,yy1);
      ss3.Read(aaa,2);
      Image3.Canvas.Pen.Color := $028888FF;
      yy2 := 100 + aaa*100 div 32767;
      Image3.Canvas.MoveTo(i,yy4);
      Image3.Canvas.LineTo(i+1,yy2);
      yy3 := yy1;
      yy4 := yy2;
    end;
  end;
  //b\
  Edit1.Text := format('%.3f-%.3f sec',[PlayCount / (44100*4),(PlayCount+2400) / (44100*4)]);
end;

procedure TForm1.MusicStop;
begin
  if (PlayNo <> 0)then DDSD1[0].Stop;
  PlayNo := 0;
  ScrollBar1.Position := PlayCount;
end;

//------------------------------------------------------------------------------
//WAVEt@C̃tH[}bg44100/16/STEREOɕϊ
procedure TForm1.ReSampleWave(var dest: TMemoryStream; src: TMemoryStream);
var
  wHed : WAVEDATAHED;
  Channel : Integer;
  Sample  : Integer;
  Bit     : Integer;
  Size    : Integer;
  i : Integer;
  Rvol,Lvol : SmallInt;
  rr1 : BYTE;
begin
  src.Position := 0;
  src.Read(wHed,sizeof(WAVEDATAHED));
  Channel := whed.Channel;
  Sample  := wHed.Sample;
  Bit     := whed.Bit;
  //
  if (dest <> nil)then dest.Free;
  dest := TMemoryStream.Create;
  //44100kHzȂ炢
  if ((Channel = 2)and(Sample = 44100)and(Bit = 16))then
  begin
    dest.SetSize(src.Size);
    src.Position := 0;
    dest.CopyFrom(src,0);
    exit;
  end;
  //wb_
  wHed.RiffHed := 'RIFF';
  wHed.WaveHed := 'WAVE';
  wHed.FmtHed  := 'fmt ';
  wHed.FmtSize := 16;
  wHed.Format  := 1;
  wHed.Channel := 2;
  wHed.Sample  := 44100;
  wHed.Avg     := 44100*2*2;
  wHed.BlockSize := 2*2;
  wHed.Bit     := 16;
  wHed.DataHed := 'data';
  size := src.Size-sizeof(WAVEDATAHED);
  if (Bit = 8    )then Size := Size * 2;
  if (Channel = 1)then Size := Size * 2;
  if (Sample = 22050)then Size := Size * 2;
  if (Sample = 11025)then Size := Size * 4;
  wHed.DataSize := Size;
  wHed.RiffSize:= Size + sizeof(WAVEDATAHED) - 8;
  dest.Write(wHed,sizeof(WAVEDATAHED));
  //ϊ
  size := src.Size-sizeof(WAVEDATAHED);
  if (Bit = 16)then Size := Size div 2;
  if (Channel = 2)then Size := Size div 2;
  for i:=0 to size-1 do
  begin
    //ǂݍ
    if (Channel = 2)then
    begin
      if (Bit = 16)then begin src.Read(RVol,2);end
                   else begin src.Read(rr1,1); RVol:= (rr1-128)*255;end;
      if (Bit = 16)then begin src.Read(LVol,2);end
                   else begin src.Read(rr1,1); LVol:= (rr1-128)*255;end;
    end
    else
    begin
      if (Bit = 16)then begin src.Read(RVol,2);end
                   else begin src.Read(rr1,1); RVol:= (rr1-128)*255;end;
      LVol := RVol;
    end;
    //Tvɂď
    if (Sample = 44100)then
    begin
      dest.Write(RVol,2);
      dest.Write(LVol,2);
    end;
    if (Sample = 22050)then
    begin
      dest.Write(RVol,2);
      dest.Write(LVol,2);
      dest.Write(RVol,2);
      dest.Write(LVol,2);
    end;
    if (Sample = 11025)then
    begin
      dest.Write(RVol,2);
      dest.Write(LVol,2);
      dest.Write(RVol,2);
      dest.Write(LVol,2);
      dest.Write(RVol,2);
      dest.Write(LVol,2);
      dest.Write(RVol,2);
      dest.Write(LVol,2);
    end;
  end;
end;

end.
